/***************************************************************************
Copyright (c) 2016 Benedikt Stockebrand
All rights reserved.

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions
are met:
1. Redistributions of source code must retain the above copyright
   notice, this list of conditions and the following disclaimer.
2. Redistributions in binary form must reproduce the above copyright
   notice, this list of conditions and the following disclaimer in the
   documentation and/or other materials provided with the distribution.

THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
SUCH DAMAGE.
***************************************************************************/


// Unless overridden in the Makefile, blink
// 7 times in a row before pausing.
// Set CFLAGS+=-DBLINKS=<n> in the Makefile
// to override.
#ifndef BLINKS
#define BLINKS 7
#endif


//========================================
// Include macro definitions etc. for the
// specific microcontroller.
#include <avr/io.h>


//========================================
// Use the built-in _ms_delay(ms) macro
// to sleep for <ms> milliseconds.
// This is AVR specific.
#ifndef F_CPU
#define F_CPU 16000000
#endif
#include <util/delay.h>



//========================================


// The fuse bits need to be set outside
// the source code, i.e. using the
// Makefile.  This is AVR specific.




int main(void)
{
  // There's one output LED at pin B5  
  DDRB |= (1<<5);
  
  for (;;)
    {
      unsigned short i;
      for (i = BLINKS; i; i--)
	{
	  PORTB |= (1<<5);   // LED on
	  _delay_ms(200);
	  PORTB &= ~(1<<5);  // LED off
	  _delay_ms(200);
	}
      _delay_ms(800);
    }
  return 0;
}
